searchData={"content_type":"text/markdown","items":[{"doc":"A list of fields to add to the translation fields\n","ref":"dsl-ashtrans-resource.html#translations-fields","title":"AshTrans.Resource.translations.fields","type":"DSL"},{"doc":"The locales to add to the translations resource\n","ref":"dsl-ashtrans-resource.html#translations-locales","title":"AshTrans.Resource.translations.locales","type":"DSL"},{"doc":"Whether the embedded resource should be public or not\n","ref":"dsl-ashtrans-resource.html#translations-public?","title":"AshTrans.Resource.translations.public?","type":"DSL"},{"doc":"","ref":"dsl-ashtrans-resource.html#translations","title":"AshTrans.Resource.translations","type":"DSL"},{"doc":"","ref":"AshTrans.Resource.html","title":"AshTrans.Resource","type":"module"},{"doc":"","ref":"AshTrans.Resource.Info.html","title":"AshTrans.Resource.Info","type":"module"},{"doc":"A list of fields to add to the translation fields","ref":"AshTrans.Resource.Info.html#translations_fields/1","title":"AshTrans.Resource.Info.translations_fields/1","type":"function"},{"doc":"A list of fields to add to the translation fields","ref":"AshTrans.Resource.Info.html#translations_fields!/1","title":"AshTrans.Resource.Info.translations_fields!/1","type":"function"},{"doc":"The locales to add to the translations resource","ref":"AshTrans.Resource.Info.html#translations_locales/1","title":"AshTrans.Resource.Info.translations_locales/1","type":"function"},{"doc":"The locales to add to the translations resource","ref":"AshTrans.Resource.Info.html#translations_locales!/1","title":"AshTrans.Resource.Info.translations_locales!/1","type":"function"},{"doc":"translations DSL options\n\nReturns a map containing the and any configured or default values.","ref":"AshTrans.Resource.Info.html#translations_options/1","title":"AshTrans.Resource.Info.translations_options/1","type":"function"},{"doc":"Whether the embedded resource should be public or not","ref":"AshTrans.Resource.Info.html#translations_public?/1","title":"AshTrans.Resource.Info.translations_public?/1","type":"function"},{"doc":"# AshTrans\n\nAshTrans is an [Ash](https://hexdocs.pm/ash) extension that provides translations to a resource.","ref":"readme.html","title":"Home","type":"extras"},{"doc":"- [Get Started with AshTrans](documentation/tutorials/get-started-with-ash-trans.md)","ref":"readme.html#tutorials","title":"Tutorials - Home","type":"extras"},{"doc":"# Get Started with AshTrans","ref":"get-started-with-ash-trans.html","title":"Get Started with AshTrans","type":"extras"},{"doc":"First, add the dependency to your `mix.exs` file\n\n```elixir\n{:ash_trans, \"~> 0.1.0\"}\n```\n\nand add `:ash_trans` to your `.formatter.exs`\n\n```elixir\nimport_deps: [..., :ash_trans]\n```","ref":"get-started-with-ash-trans.html#installation","title":"Installation - Get Started with AshTrans","type":"extras"},{"doc":"To add translations to a resource, add the extension to the resource:\n\n```elixir\nuse Ash.Resource,\n  extensions: [..., AshTrans.Resource]\n\ntranslations do\n  # Add public or add :translations to action accept list\n  public? true\n  # Add the fields you want to translate\n  fields [:name, :description]\n  # Add the locales, except the default locale\n  locales [:it]\nend\n```\n\nIf you are using Cldr, add the provider to your Cldr module:\n\n```elixir\nuse Cldr,\n  providers: [AshTrans],\n  locales: [\"it\", \"en\"]\n```\n\nThen use the provider function for a locale list with the default excluded:\n\n```elixir\ntranslations do\n  locales MyApp.Cldr.AshTrans.locale_names()\nend\n```\n\nTo translate a resource, just do this:\n\n```elixir\n# If you have Cldr\nMyApp.Cldr.AshTrans.translate(resource)\n# If you don't have Cldr\nAshTrans.translate(resource, locale)\n```\n\nYou can also translate just a field:\n\n```elixir\n# If you have Cldr\nMyApp.Cldr.AshTrans.translate_field(resource, field)\n# If you don't have Cldr\nAshTrans.translate_field(resource, field, locale)\n```","ref":"get-started-with-ash-trans.html#adding-to-a-resource","title":"Adding to a resource - Get Started with AshTrans","type":"extras"},{"doc":"To use with AshPhoenix, there is a helper provided to add the required forms:\n\n```elixir\n# Or Form.for_create\nForm.for_update(activity_price_category, :update,\n  # This is necessary, alternatively you can define them manually\n  forms: [auto?: true],\n  prepare_source: fn changeset ->\n    # For the language selection later\n    Ash.Changeset.set_argument(changeset, :locale, MyApp.Cldr.get_locale().cldr_locale_name)\n  end\n)\n|> AshTrans.add_forms(locales)\n# If you are using Cldr\n# |> AshTrans.add_forms(Cldr.AshTrans.locale_names())\n```","ref":"get-started-with-ash-trans.html#using-with-ashphoenix","title":"Using with AshPhoenix - Get Started with AshTrans","type":"extras"},{"doc":"```heex\n<.input\n  type=\"select\"\n  label={gettext(\"Language\")}\n  field={@form[:locale]}\n  options={\n    Enum.map(MyApp.Cldr.known_locale_names(), &{MyApp.Cldr.LocaleDisplay.display_name!(&1), &1})\n  }\n/>\n\n<.input\n  class={hide_input?(@form[:locale]) && \"hidden\"}\n  label={gettext(\"Name\")}\n  field={@form[:name]}\n/>\n\n<.inputs_for :let={translations} field={@form[:translations]}>\n  <.inputs_for\n    :let={field}\n    :for={locale <- MyApp.Cldr.AshTrans.locale_names()}\n    field={translations[locale]}\n  >\n    <.input\n      class={hide_translation_input?(@form[:locale], locale) && \"hidden\"}\n      label={gettext(\"Name\")}\n      field={field[:name]}\n    />\n  </.inputs_for>\n</.inputs_for>\n```\n\n```elixir\ndefp hide_input?(field) do\n  field.value &&\n    to_string(field.value) != to_string(MyApp.Cldr.default_locale().cldr_locale_name)\nend\n\ndefp hide_translation_input?(field, locale) do\n  !field.value || to_string(field.value) != to_string(locale)\nend\n```","ref":"get-started-with-ash-trans.html#example","title":"Example - Get Started with AshTrans","type":"extras"},{"doc":"<!--\nThis file was generated by Spark. Do not edit it by hand.\n-->\n# DSL: AshTrans.Resource","ref":"dsl-ashtrans-resource.html","title":"DSL: AshTrans.Resource","type":"extras"},{"doc":"","ref":"dsl-ashtrans-resource.html#translations","title":"translations - DSL: AshTrans.Resource","type":"extras"},{"doc":"| Name | Type | Default | Docs |\n|------|------|---------|------|\n| [`public?`](#translations-public?){: #translations-public? } | `boolean` | `false` | Whether the embedded resource should be public or not |\n| [`locales`](#translations-locales){: #translations-locales } | `list(atom)` | `[]` | The locales to add to the translations resource |\n| [`fields`](#translations-fields){: #translations-fields } | `list(atom)` | `[]` | A list of fields to add to the translation fields |\n\n\n\n\n\n\n\n .spark-required::after { content: \"*\"; color: red !important; }","ref":"dsl-ashtrans-resource.html#options","title":"Options - DSL: AshTrans.Resource","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}